package ac.essex.ooechs.imaging.commons.apps.training.strategies;

import ac.essex.ooechs.imaging.commons.Pixel;
import ac.essex.ooechs.imaging.commons.util.CSVWriter;
import ac.essex.ooechs.imaging.commons.util.CSVReader;

import java.util.Vector;
import java.io.File;
import java.io.IOException;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 28-Jul-2008
 * @version 1.0
 */
public class NodeSaver {

    public static Vector<Pixel> load(File f) throws IOException {
        Vector<Pixel> nodes = new Vector<Pixel>();
        CSVReader r = new CSVReader(f);
        while (r.hasMoreLines()) {
            r.getLine();
            nodes.add(new Pixel(r.getInt(0), r.getInt(1)));
        }
        return nodes;
    }

    public static void save(Vector<Pixel> nodes, File f) throws IOException {
        CSVWriter w = new CSVWriter();
        for (int i = 0; i < nodes.size(); i++) {
            Pixel pixel = nodes.elementAt(i);
            w.addData(pixel.x);
            w.addData(pixel.y);
            w.newLine();
        }
        w.save(f);
    }         

}
