package ac.essex.ooechs.imaging.commons.noise;

import ac.essex.ooechs.imaging.commons.PixelLoader;
import ac.essex.ooechs.imaging.commons.util.panels.ImagePanel;
import ac.essex.ooechs.imaging.commons.util.panels.ImageFrame;

import java.awt.image.BufferedImage;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: ooechs
 * Date: 27-Nov-2008
 * Time: 10:59:06
 * To change this template use File | Settings | File Templates.
 */
public class NoiseDemo {

    public static void main(String[] args) throws Exception {

        PixelLoader image = new PixelLoader("M:\\pc\\desktop\\noise.png");
        BufferedImage gaussian = new BufferedImage(image.getHeight(), image.getWidth(), BufferedImage.TYPE_INT_ARGB);
        BufferedImage median = new BufferedImage(image.getHeight(), image.getWidth(), BufferedImage.TYPE_INT_ARGB);
        BufferedImage truncatedMedian = new BufferedImage(image.getHeight(), image.getWidth(), BufferedImage.TYPE_INT_ARGB);

        int[] rgb = new int[256];
        for (int i = 0; i < rgb.length; i++) {
            rgb[i] = new Color(i,i,i).getRGB();
        }

        int size = PixelLoader.size;

        for (int ny = size; ny < image.getHeight()-size; ny++) {
            for (int nx = size; nx < image.getWidth()-size; nx++) {
                try {
                gaussian.setRGB(nx, ny, rgb[(int) image.get3x3Gaussian(nx, ny)]);
                median.setRGB(nx, ny, rgb[image.get3x3Median(nx, ny)]);
                truncatedMedian.setRGB(nx, ny, rgb[(int) image.get3x3TruncatedMedian(nx, ny, 1)]);
/*                gaussian.setRGB(nx, ny, rgb[(int) image.get3x3TruncatedMedian(nx, ny, 1)]);
                median.setRGB(nx, ny, rgb[(int) image.get3x3TruncatedMedian(nx, ny, 2)]);
                truncatedMedian.setRGB(nx, ny, rgb[(int) image.get3x3TruncatedMedian(nx, ny, 3)]);*/
                } catch (Exception e) {}
            }
        }

        new ImageFrame(image.getBufferedImage(), "Original").setLocation(0,0);
        new ImageFrame(gaussian, "Gaussian").setLocation(100,100);
        new ImageFrame(median, "Median").setLocation(200, 200);
        new ImageFrame(truncatedMedian, "Truncated Median").setLocation(300, 300);


    }

}
