package ac.essex.ooechs.imaging.commons.util;

import java.io.FilenameFilter;
import java.io.File;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 05-Oct-2006
 * @version 1.0
 */
public class CSVFilenameFilter implements FilenameFilter {

    public boolean accept(File dir, String name) {
        return isCSVFile(name);
    }

    public static boolean isImage(File f) {
        return isCSVFile(f.getName());
    }

    public static boolean isCSVFile(String filename) {

        filename = filename.toLowerCase();

        if (filename.endsWith(".csv")) return true;

        return false;

    }

}
