package ac.essex.ooechs.imaging.commons.util.panels;

import ac.essex.ooechs.imaging.commons.PixelLoader;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

/**
 * Displays an Image in its own Frame.
 *
 * @author Olly Oechsle, University of Essex, Date: 19-Jan-2007
 * @version 1.0
 */
public class ImageFrame extends JFrame {

    public static final String DEFAULT_TITLE = "Image Viewer";

    public ImagePanel imagePanel;

    public ImageFrame(PixelLoader image) {
        this(null, image.getBufferedImage(), null);
    }

    public ImageFrame(JFrame owner, PixelLoader image)  {
        this(owner, image.getBufferedImage(), null);
    }

    public ImageFrame(BufferedImage image)  {
        this(null, image, null);
    }

    public ImageFrame(BufferedImage image, String title)  {
        this(null, image, title);
    }

    public ImageFrame(JFrame owner, BufferedImage image, String title) {

        super(title == null? DEFAULT_TITLE : title);
        
        Container c = getContentPane();

        imagePanel = new ScalingImagePanel();
        imagePanel.setImage(image);
        imagePanel.setDisplayCentered(true);

        c.add(imagePanel);

        if (owner == null) {
            setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        }

        setSize(image.getWidth() + 100, image.getHeight() + 100);
        setVisible(true);

        try {
        new PixelLoader(image).saveAs("m:\\pc\\Desktop\\" + title + ".png");
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

}
