package ac.essex.ooechs.imaging.commons.window.util;

import ac.essex.ooechs.imaging.commons.PixelLoader;
import ac.essex.ooechs.imaging.commons.util.CSVWriter;
import ac.essex.ooechs.imaging.commons.window.WindowGUI;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;


/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 11-Apr-2008
 * @version 1.0
 */

public class FeaturesFromDirectory extends JDialog implements ActionListener {

    JTextField classID;
    JTextField directory;
    JTextArea output;
    JButton process;
    JButton close;

    WindowGUI owner;

    public FeaturesFromDirectory(WindowGUI owner) {

        super(owner);

        setTitle("Generate Features From Images");

        this.owner = owner;

        directory = new JTextField(owner.fileTree.getCurrentDirectory().getAbsolutePath());
        process = new JButton("Process");

        classID = new JTextField("0");

        JPanel top = new JPanel(new BorderLayout());
        top.add(directory, BorderLayout.CENTER);
        top.add(classID, BorderLayout.WEST);
        top.add(process, BorderLayout.EAST);

        process.addActionListener(this);

        output = new JTextArea("");

        close = new JButton("Close");
        close.addActionListener(this);

        Container c = getContentPane();
        c.add(top, BorderLayout.NORTH);
        c.add(new JScrollPane(output), BorderLayout.CENTER);
        c.add(close,BorderLayout.SOUTH);

        setSize(400, 300);
        setVisible(true);

    }

    public void actionPerformed(ActionEvent e) {

        if (e.getSource() == close) {
            dispose();
        }

        if (e.getSource() == process) {


                File directory = new File(this.directory.getText());
                if (directory.exists() && directory.isDirectory()) {

                    File[] files = directory.listFiles();

                    CSVWriter writer = new CSVWriter();

                    for (int i = 0; i < files.length; i++) {
                        File f = files[i];
                        try {
                        PixelLoader img = new PixelLoader(f);
                        ac.essex.ooechs.imaging.commons.window.data.Window window = new ac.essex.ooechs.imaging.commons.window.data.Window(img.getWidth(), img.getHeight(), 0, 0, null);
                        double[] values = WindowFeatures.getFeatures(img, window);
                        writer.addData(values);
                        writer.addData(Integer.parseInt(classID.getText()));
                        writer.newLine();
                        } catch (Exception err) {
                            // don't worry too much
                        }
                    }

                    output.setText(writer.toString());

                }


        }

    }        


}

