package ac.essex.ooechs.imaging.commons.window.util;

import javax.swing.filechooser.FileFilter;
import java.io.File;

public class FileFilters {

    public static FileFilter getWindowProjectFilter() {
        return new FileFilter() {
            public boolean accept(File f) {
                String extension = f.getName().substring(f.getName().lastIndexOf('.') + 1).toLowerCase();
                if (f.isDirectory()) return true;
                if (extension.equals("windows")) return true;
                return false;
            }

            public String getDescription() {
                return "Window Projects, *.windows";
            }
        };
    }

    public static FileFilter getCSVFilter() {
        return new FileFilter() {
            public boolean accept(File f) {
                String extension = f.getName().substring(f.getName().lastIndexOf('.') + 1).toLowerCase();
                if (f.isDirectory()) return true;
                if (extension.equals("csv")) return true;
                return false;
            }

            public String getDescription() {
                return "Comma Separated Values, *.csv";
            }
        };
    }

    public static FileFilter getClassFileFilter() {
        return new FileFilter() {
            public boolean accept(File f) {
                String extension = f.getName().substring(f.getName().lastIndexOf('.') + 1).toLowerCase();
                if (f.isDirectory()) return true;
                if (extension.equals("class")) return true;
                return false;
            }

            public String getDescription() {
                return "Java Class Files, *.class";
            }
        };
    }

    public static FileFilter getImageFilter() {
        return new FileFilter() {
            public boolean accept(File f) {
                String extension = f.getName().substring(f.getName().lastIndexOf('.') + 1).toLowerCase();
                if (f.isDirectory()) return true;
                if (extension.equals("bmp")) return true;
                if (extension.equals("jpg")) return true;
                if (extension.equals("png")) return true;
                if (extension.equals("gif")) return true;
                return false;
            }

            public String getDescription() {
                return "Image Files: jpg, png, gif, bmp";
            }
        };
    }


}

